<html>
<head>
<title>Simple Programming Language</title>
</head>

<body>
<center><table width="500px"><tr><td>
<font face="Helvetica" size="-1">
<h1>Simple Programming Langauge</h1>
<p>The goal of SPL is to be as human readable as possible while still retaining features that make it useful as a programming language.  The syntax is designed to read like a book instead of being terse and requiring a great deal of deciphering to understand.</p>

<br><h2>Language Definition</h2>
<h3>Variables and Constants</h3>
<p>SPL currently supports integers only.  An integer can be represented as a series of digits.  For example:</p>
<pre>5
120</pre>
<p>Variable names may consist of uppercase letters, lowercase letters, digits, hyphens, and underscores.  They must begin with a letter.  Certain keywords are reserved.</p>

<h3>Expressions</h3>
<p>The following simple arithmatic expressions are supported: plus, minus, divided by, times.  Prescedence may not work as expected.  Parenthesis may be used to explicitly state prescedence.  Some examples:</p>
<pre>5 plus 10
23 times (12 plus 3)
100 divided by (12 times (2 plus 1))</pre>

<h3>Assignment</h3>
<p>To assign a value to a global variable, use the syntax <pre>put <i>value</i> into <i>variable</i></pre> and replace <i>value</i> and <i>variable</i> with the appropriate information.  The value may be an integer constant, another variable (this will assign by value, not reference), or an expression.  For example:</p>
<pre>put 23 into class_size
put class_size into temp
put 12 times hotdog into amount_to_buy</pre>
<p>Local variables are not currently supported.</p>

<h3>Conditions</h3>
<p>To use a conditional statement the programmer must precede it with "check that."  SPL supports a number of redundant conditions to allow the programmer to express his or her intentions as clearly as possible.  The following conditions are valid in SPL:</p>
<ul><li>is equal to</li>
<li>is not equal to</li>
<li>is greater than</li>
<li>is not greater than</li>
<li>is less than</li>
<li>is not less than</li>
<li>is greater than or equal to</li>
<li>is not greater than or equal to</li>
<li>is less than or equal to</li>
<li>is not less than or equal to</li>
</ul>
<p>Tests are conducted by value, so two separate variables that both contain 5, for example, are equal.  Some examples:</p>
<pre>check that 5 is less than 10
check that class_size is equal to 20
check that cost is not greater than budget</pre>

<h3>Selection</h3>
<p>SPL supports a simple if/otherwise statement to provide selection. The syntax is as follows: </p>
<pre>if <i>comparison</i>:
 ...
otherwise:
 ...
end if</pre>
<p>A comparison must be used as the test for an if statement.  SPL does not support the C-style convention of 0 being false and all else being true; code is more obvious and easier to read when the condition is spelled out.</p>

<h3>Iteration</h3>
<p>Iteration in SPL is accomplished with a while loop.  For example:</p>
<pre>while number_of_students is less than 20:
 put number_of_students plus 1 into number_of_students
loop</pre>

<h3>Printing</h3>
<p>SPL supports a simple print statement.  Expressions or conditions can be printed.</p>
<pre>print 2
print var
print (9 plus var) times 2
print check if 9 is greater than or equal to 10</pre>

<br><h2>Sample Programs</h2>
<h3>Fibonacci</h3>
<p>This program will calculate the fifth fibonacci number.</p>
<pre>put 5 into number_to_find
put 1 into current_number
put 0 into fib_number

put 0 into one_ago
put 1 into two_ago

while check that current_number is less than number_to_find:
 put one_ago plus two_ago into fib_number
 put one_ago into two_ago
 put fib_number into one_ago
 put current_number plus 1 into current_number 
loop

print fib_number
</pre>

<h3>Simple Selection</h3>
<p>This program will select the larger of two variables and subtract from it half of the smaller variable.</p>
<pre>put 20 into first_variable
put 10 into second_variable

if check that first_variable is greater than second_variable:
 put first_variable minus (second_variable divided by 2) into result
otherwise:
 put second_variable minus (first_variable divided by 2) into result
end if

print result
</pre>
</font>
</td></tr></table></center>
</body>
</html>
